//****************************************************************************
writeHexByte:
; d0.b value
; a0 adress to write;
	movem.l	d0-d1/a1,-(a7)
	lea		hex(pc),a1
	move	d0,d1
	and		#$f,d0
	lsr		#4,d1
	and		#$f,d1
	move.b	(a1,d0),1(a0)
	move.b	(a1,d1),(a0)
	movem.l	(a7)+,d0-d1/a1
	rts
writeHexWord:
; d0.w value
; a0 adress to write;
	movem.l	d0-d1/a1,-(a7)
	lea		(a0),a1
	lea		2(a1),a0
	jsr		writeHexByte
	lsr		#8,d0
	lea		(a1),a0
	jsr		writeHexByte
	movem.l	(a7)+,d0-d1/a1
	rts
writeHexLong:
; d0.l value
; a0 adress to write;
	movem.l	d0-d1/a1,-(a7)
	lea		(a0),a1
	lea		4(a1),a0
	jsr		writeHexWord
	swap	d0
	lea		(a1),a0
	jsr		writeHexWord
	movem.l	(a7)+,d0-d1/a1
	rts
//****************************************************************************
clearScreen:
	move.l	$44e.w,a0
	move	#(160*200/4)-1,d0
.clearScreenLoop:
	clr.l 	(a0)+
	dbf		d0,.clearScreenLoop
	rts
//****************************************************************************
printStates:


	lea		state68KText(pc),a0
	move	#14,d0
	move	#11,d1
	bsr		printText

	move	state,d0
	lsl		#4,d0
	ext.l d0
	lea		state68KTexts(pc),a0
	add.l	d0,a0
	move	#14,d0
	move	#12,d1
	bsr		printText

	move	stateFPGA,d0
	lea		fpgaStateNumber(pc),a0
	bsr		writeHexByte

	move	stateFPGARet,d0
	lea		fpgaStateNumber+3(pc),a0
	bsr		writeHexByte
	
	lea		fpgaStateText(pc),a0
	move	#0,d0
	move	#11,d1
	bsr		printText
	rts

//****************************************************************************
printUploadCounter:
	move	uploadCount,d0
	lea		lenText(pc),A0
	bsr		writeHexWord
	
	move	byteCount,d0
	lea		lenText+5(pc),A0
	bsr		writeHexWord
	
	lea		lenText(pc),A0
	move	#0,d0
	move	#13,d1
	bsr		printText
	rts
//****************************************************************************
printText:
; a0 text
	move.l	$44e.w,a1
	mulu	#160*10,d1
	move	d0,d6
	movem.l	d0-a6,-(a7)
.write	moveq	#0,d2
	move.b	(a0)+,d2
	beq.b	.end
	cmp.b	#10,d2
	bne.b	.nonew
	move	d6,d0
	add.w	#160*10,d1
;	add.w	d1,d0
	bra.b	.write
.nonew		sub.w	#" ",d2
	lsl.w	#3,d2
	lea		UDFont(pc),a2
	lea		(a2,d2.w),a2
	move 	d0,d4
	move	d0,d5
	and		#$1,d4
	lsr		#1,d5
	lsl		#3,d5
	add		d5,d4
	add		d1,d4
	lea		(a1,d4.w),a3

	move.b	(a2)+,(a3)
	move.b	(a2)+,160*1(a3)
	move.b	(a2)+,160*2(a3)
	move.b	(a2)+,160*3(a3)
	move.b	(a2)+,160*4(a3)
	move.b	(a2)+,160*5(a3)
	move.b	(a2)+,160*6(a3)
	move.b	(a2)+,160*7(a3)
	addq.w	#1,d0
	bra.b	.write
.end	movem.l	(a7)+,d0-a6
	rts
